/* 8bit u-law / 8kHz λ constant data 
 * shige
 * 02/25 1999
 * 08/21 2000 
 * auconst.c
 *
 * $Id: auconst.c,v 1.6 2017-03-09 12:16:44+09 shige Exp $
 */
/* 02/25 1999
 * 1) Ĺ constant data äƤ fill Τߡ
 *      -n [num]: data Ĺ
 *      -s [string]: data (16 )
 *      -i [int]: data (10 )
 */
/* #define DEBUG1 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "auio.h"

#define Buffsize 1024
#define uns(s) ((unsigned char *)(s))
#define str4byte2x(s) (uns(s)[0]<<24 | uns(s)[1]<<16 | uns(s)[2]<<8 | uns(s)[3])
#define Def_datanum 10
#define Def_dataint 0
#define Def_datalen 1

int main(int argc, char *argv[]);
int setstrdata2buff(char *buff, char *str);
int s2i(char c);
void usage(void);

int main(int argc, char *argv[])
{
    AUdata audata = {
	0, 	/* magic number */
	32, 	/* data  offset */
	0,  	/* data Ĺ */
	1,  	/* data format code (1= 8bit mu - low) */
	8000, 	/* sampling rate */
	1, 	/* cannel  */
	NULL
    };
    int datanum = Def_datanum;
    char buff[Buffsize];
    int dataint = Def_dataint;
    int datalen = Def_datalen;
    int j, k;
    FILE *outfile = stdout;

    audata.magic = str4byte2x(".snd");
 
    while (-- argc > 0) {
	if (**(++ argv) == '-') {
	    switch (*(++ *argv)) {
	    case 'n':
		if (*(++ *argv) == '\0') { 
		    if (-- argc <= 0) { usage(); return 1; }
		    else argv ++;
		}
		datanum = atoi(*argv);
		break;
	    case 'i':
		if (*(++ *argv) == '\0') { 
		    if (-- argc <= 0) { usage(); return 1; }
		    else argv ++;
		}
		dataint = atoi(*argv);
		if (dataint < 0 || dataint > 255) {
		    usage(); return 2; 
		}
		buff[0] = dataint; datalen = 1;
		break;
	    case 's':
		if (*(++ *argv) == '\0') { 
		    if (-- argc <= 0) { usage(); return 1; }
		    else argv++;
		}
		datalen = setstrdata2buff(buff, *argv);
		if (datalen <= 0) { usage(); return 3; }
		break;
	    case 'o':
		if (*(++ *argv) == '\0') { 
		    if (-- argc <= 0) { usage(); return 1; }
		    else argv++;
		}
		if ((outfile = fopen(*argv, "w")) ==NULL) { 
		    usage(); return 6; 
		}
		break;
	    case 'h':
	    case 'H':
	    case '?':
		usage(); return 0;
	    default:
		usage(); return 4;
	    }
	}
	else { usage(); return 5; }
    }
    audata.datalen = datalen*datanum;
    putAUheader(outfile, &audata);
    for (j=1; j<=datanum; j++)
	for (k=0; k<datalen; k++) fputc(buff[k], outfile);
    if (outfile != stdout) fclose(outfile);
    return 0;
}

/* 16 ʸ str  buff ˵ͤ
 */
int setstrdata2buff(char *buff, char *str)
{
    int len, j;

    if ((len = strlen(str)) < 0) return -1;
    else if (len == 0) return 0;
    else if ((len + 1)/2 > Buffsize) return -2;
    if (len%2) {
	if (!isxdigit(*str)) return -3;
	*(buff ++) = s2i(*(str ++));
    }
    for (j=1; j<=len/2; j++) {
	if (!isxdigit(*str) || !isxdigit(*(str + 1))) return -3;
	*(buff ++) = s2i(*str) << 4 | s2i(*(str + 1));
	str += 2;
    }
    return (len + 1)/2;
}

int s2i(char c)
{
    if (c >= '0' && c <= '9') return c - '0';
    else if (c >= 'a' && c <= 'f') return c - 'a' + 10;
    else if (c >= 'A' && c <= 'F') return c - 'A' + 10;
    else return -1;
}

void usage(void)
{
    char *mess[] = {
	"Usage: auconst (-n [num]) (-s [data]) (-i [data]) (-o [name]) (-h)",
	"  -n [num] : ܥ֥åη֤ (default: 10)",
	"  -s [data]: ǡܥ֥åʸ (16 ʿ) (default: ʤ)",
	"  -i [data]: ǡ 1 Х (10 0~255) (default: 0)",
	"  -o [name]: ϥե̾ (default: ɸ)",
	"  -h: Υå",
	NULL
    };
    int j;

    for (j=0; mess[j]!=NULL; j++) fprintf(stderr, "%s\n", mess[j]);
}

