/* conf.c إåե
 * 09/30 2000
 * shige
 * conf.h
 *
 * $Id: conf.h,v 1.15 2017-03-30 21:22:41+09 shige Exp $
 */
#ifndef __CONF_H__
#define __CONF_H__

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#include "common.h"
#include "cstruct.h"
#include "error.h"


/* */
#define Listdelimiter ':'

#define Maxpathlists 100
#define Maxpathlen 8192
#define Maxextlists 20
#define Maxextlen 20

#define Maxnullflen 512

/* ##### conf.c ##### */
#ifdef __CONF_C__
#define Confcomment '#'

char *pathlist[Maxpathlists];
int pathlistnum = 0;
int order[Maxpathlists];

char *extlist[Maxextlists];
int extlistnum = 0;

#define Confdelimiter " \t\n"
#define Maxbuff 8192

#define Pathdelimiter '/'
#define Homechar '~'

char *HOME = NULL;
char *NULLFname = NULL, nullfbuff[Maxnullflen];

#ifdef AUDEFAULTPATHLIST
#define AU_Pathlist AUDEFAULTPATHLIST
#else
#define AU_Pathlist "/usr/local/audio/lib/audata:"
#endif
#ifdef WAVDEFAULTPATHLIST
#define WAV_Pathlist WAVDEFAULTPATHLIST
#else
#define WAV_Pathlist "/usr/local/audio/lib/wavdata:"
#endif
#ifdef AIFFDEFAULTPATHLIST
#define AIFF_Pathlist AIFFDEFAULTPATHLIST
#else
#define AIFF_Pathlist "/usr/local/audio/lib/aiffdata:"
#endif
#define AU_Extlist ".au:.AU:"
#define AU_Conffname "~/.auconnrc"
#define AU_ExtEnvname "AUDATAEXT"
#define AU_PathEnvname "AUDATAPATH"
#define AU_NULLFEnvname "AUNULLFILE"
#define WAV_Extlist ".wav:.WAV:"
#define WAV_Conffname "~/.wavconnrc"
#define WAV_ExtEnvname "WAVDATAEXT"
#define WAV_PathEnvname "WAVDATAPATH"
#define WAV_NULLFEnvname "WAVNULLFILE"
#define AIFF_Extlist ".aif:.aiff:.AIF:.AIFF:"
#define AIFF_Conffname "~/.aiffconnrc"
#define AIFF_ExtEnvname "AIFFDATAEXT"
#define AIFF_PathEnvname "AIFFDATAPATH"
#define AIFF_NULLFEnvname "AIFFNULLFILE"

#define CurListName "CURLIST"

enum OptionID { 
    Ipath, Iext, Inullfile, Ilength, Ispeed, 
    Idecres, Icres, Iporder, 
    Ilast
};
char *OptionNames[] = { 
    "path", "ext", "nullfile", "length", "speed", 
    "decres", "cres", "porder" 
};
enum OptionMode {
    Moverride, Mappend, Mprepend, Mnochange,
    Mlast
};
int OptionMode[] = {
    Mappend, Mappend, Moverride, Moverride, Moverride,
    Moverride, Moverride, Moverride
};

#if 0
char *DEFAULTExtlist[]
	= {AU_Extlist, WAV_Extlist, AIFF_Extlist};
char *DEFAULTPathlist[]
	= {AU_Pathlist, WAV_Pathlist, AIFF_Pathlist};
char *DEFAULTConffname[]
	= {AU_Conffname, WAV_Conffname, AIFF_Conffname};
char *DEFAULTExtEnvname[]
	= {AU_ExtEnvname, WAV_ExtEnvname, AIFF_ExtEnvname};
char *DEFAULTPathEnvname[]
	= {AU_PathEnvname, WAV_PathEnvname, AIFF_PathEnvname};
char *DEFAULTNULLFEnvname[]
	= {AU_NULLFEnvname, WAV_NULLFEnvname, AIFF_NULLFEnvname};
#else
char *DEFAULTExtlist = NULL;
char *DEFAULTPathlist = NULL;
char *DEFAULTConffname = NULL;
char *DEFAULTExtEnvname = NULL;
char *DEFAULTPathEnvname = NULL;
char *DEFAULTNULLFEnvname = NULL;
#endif
double Mintimes = 0.005;

/* ##### defined in auconn.h ##### */
extern int verbose;
extern int listonly;
extern ConnOpt defopt;
#endif /* __CONF_C__ */

#ifdef __CONF_C__
# define EXTERN_CONF 
#else
# define EXTERN_CONF extern 
#endif

EXTERN_CONF int setsystemdefault(ConnOpt *opt);
EXTERN_CONF int loadenv(char *env[]);
EXTERN_CONF int loadconffile(char *fname, ConnOpt *opt);
EXTERN_CONF void initdefvar(int format);
EXTERN_CONF int setL(char *str, ConnOpt *opt);
EXTERN_CONF int setS(char *str, ConnOpt *opt);
EXTERN_CONF int setD(char *str, ConnOpt *opt);
EXTERN_CONF int setC(char *str, ConnOpt *opt);
EXTERN_CONF int setP(char *str, ConnOpt *opt);
EXTERN_CONF int inithome(char *env[]);
EXTERN_CONF char *newfname(char *fname);
EXTERN_CONF FILE *searchextlist(char *fname);
EXTERN_CONF void randomperm(int h[], int num);
EXTERN_CONF void initorder(void);
EXTERN_CONF int updateorder(int mode, int param);
EXTERN_CONF FILE *fopenpathlist(char *fname, int mode, int param,
				int *pathnum);
EXTERN_CONF void allfree(char *array[], int curnum);
EXTERN_CONF int updatelist(char *list[], int curnum, int Maxlist,
			   char *liststr, int Maxlen);
EXTERN_CONF char *mystrtok(char *str, char c);
EXTERN_CONF char *mystrcat(char *str, char c);
EXTERN_CONF int iswithpath(char *filename);

#ifdef DEBUG4
EXTERN_CONF void putallpathlist(void);
EXTERN_CONF void putallextlist(void);
EXTERN_CONF void putallopt(ConnOpt *opt, int filenum);
#endif

#endif /* __CONF_H__ */
