/* ǡƥȥ٥ǡѴ
 * 10/14 2005
 * shige
 * snd2txt.c
 *
 * $Id: snd2txt.c,v 1.3 2017-03-06 17:54:00+09 shige Exp $
 */
/* snd2txt (-t[n]) (-c[n]) ([file])
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "common.h"

#define Maxchan 50

int main(int argc, char *argv[]);
int getarg(int argc, char **argv, int *comment, int *usetime,
	   FILE **infile);
void usage(int ret);

int main(int argc, char *argv[])
{
    FILE *infile, *outfile = stdout;
    SNDheader snd;
    int ch, format, blocks, bps;
    int j, k, ret;
    int comment = 1, usetime = 0;
    double smpl;
    
    if ((ret = getarg(argc, argv, &comment, &usetime, &infile)) <= 0) {
	usage(ret); return -ret;
    }
    if ((format = getSNDheader(infile, &snd)) < 0 
	|| format == E_UNKNOWN) {
	fprintf(stderr, "Error :  In getSNDheader(). (%d)\n", ret);
	return 20;
    }
    if ((ch = SNDchannels(&snd, format)) > Maxchan) {
	fprintf(stderr, "Error :  too many channels in data. (%d)\n",
		ch);
	return 25;
    }
    blocks = SNDblocks(&snd, format);
    if ((smpl = SNDsmplrate(&snd, format)) <= 0) {
	fprintf(stderr, "Error :  sampling rate. (%f)\n", smpl);
	return 30;
    }
    bps = SNDbitpersmpl(&snd, format);
    if (comment) {
	switch (format) {
	case E_AU:
	    fprintf(outfile, "; original :  AU format\n"); break;
	case E_WAV:
	    fprintf(outfile, "; original :  WAV format\n"); break;
	case E_AIFF:
	    fprintf(outfile, "; original :  AIFF format\n"); break;
	}
	fprintf(outfile, "; Sample Rate %f\n", smpl);
	fprintf(outfile, "; %d blocks\n", blocks);
	fprintf(outfile, "; %d bitpersample\n", bps);
    } else
      fprintf(outfile, "; Sample Rate %d\n", (int) smpl);
    for (j=1; j<=blocks; j++) {
	if (usetime) fprintf(outfile, " %.8f", (j - 1)/smpl);
	for (k=1; k<=ch; k++) 
	  fprintf(outfile, " %.8f",
		  SNDget1chleveldata(infile, &snd, format));
	fprintf(outfile, "\n");
    }
    return 0;
}

int getarg(int argc, char **argv, int *comment, int *usetime,
	   FILE **infile)
{
    *infile = stdin;

    while (-- argc > 0) {
	if (**(++ argv) == '-') {
	    switch (*(++*argv)) {
	    case 'h':
	    case 'H':
	    case '?': return 0;
            case 'c': 
                if (*(++ *argv) == '\0') { 
                    if (-- argc <= 0) return -1;
                    else argv ++;
                }
                if ((*comment = atoi(*argv)) != 1 && *comment != 0)
		  return -2;
                break;
            case 't': 
                if (*(++ *argv) == '\0') { 
                    if (-- argc <= 0) return -1;
                    else argv ++;
                }
                if ((*usetime = atoi(*argv)) != 1 && *usetime != 0)
		  return -3;
                break;
	    case '\0': break;
	    default: return -6;
	    }
	    if (**argv == '\0') { -- *argv; break; }
	} else break;
    }
    if (argc > 1) {
#ifdef DEBUG1
	fprintf(stderr, "DEBUG1: %d\n", argc);
#endif
	return -7;
    }
    if (argc < 1 || ! strcmp(*argv, "-")) *infile = stdin;
    else if ((*infile = fopen(*argv, "r")) == NULL) {
	fprintf(stderr, "File [%s] open error.\n", *argv);
	return -9;
    }
    return 1;
}

void usage(int ret)
{
    char *mess[] = {
	"Usage: snd2txt (-t[n]) (-c[n]) ([infile])",
	"   [infile]: ϥե (ά: ɸ)",
"   -t[n]: [n] = 1: ƹ 1 ܤϻǡˤ / [n] = 0: ʤ (default)",
"   -c[n]: [n] = 1: ƬΥȤɲä (default)[n] = 0: ʤ",
	" ",
	" [1] Υ٥ǡ򥵥ץ˥ƥȥǡȤƽϤ",
	"     롣ʣͥǡϡƹԤʣΥǡ¤٤롣",
	" [2] Ϥɸϡ",
	" [3] -t1 ξϡsox  .dat Ʊͤ˳ƹ 1 ܤˤΥץ",
	"     Ϥ롣-t0 ξ (default) ϤνϤϹԤʤ",
	" [4] -c1 ξ (default) ϡsox  .dat Ƭդץ",
	"     ȿʳˡΥǡβǡ֥å̻Ҳ",
	"     ӥåȿ⥳ȽϤ롣-c0 ξ sox .dat Ʊͥ",
	"     ץ󥰼ȿΤߥȽϤ롣äơ-t1 -c0 Ȥ",
	"     sox .dat ߴνϤԤ롣",
	" [5] νϤ txt2snd ˿碌硢-t1 ΥǡϡƹԤ 1 ",
	"     ܤƤ txt2snd ˿碌뤫txt2snd νϤ 1 ",
	"     ͥܤΥǡ sndchmix  sndchan ʤɤǼɬפ",
	"      (-t0 ΥǡʤϤʤ)",
	NULL
    };
    int j;

#ifdef DEBUG1
    printf("USAGE: %d\n", ret);
#endif
    for (j=0; mess[j]!=NULL; j++) fprintf(stderr, "%s\n", mess[j]);
}
