/* 
 * ղ
 * shige
 * 12/30 2003
 * 
 * $Id: sndrev.c,v 1.10 2017-03-01 12:18:46+09 shige Exp $
 *
 *  fseek ʤǤˤ tmpfile Ȥʤ
 */
#include <stdio.h>
#include <stdlib.h>
#include "common.h"

int main(int argc, char *argv[]);
int getarg(int argc, char **argv, FILE **infile, FILE **outfile);
void usage(int ret);

int main(int argc, char *argv[])
{
    FILE *infile, *outfile;
    SNDheader snd;
    int format, ch, bs;
    long int dlen, blocks;
    FILE *tmp;
    int j, k, ret;
    double x;

    if ((ret = getarg(argc, argv, &infile, &outfile)) <= 0) {
	usage(ret); return -ret;
    }
    if ((format = getSNDheader(infile, &snd)) < 0 
	|| format == E_UNKNOWN) {
        fprintf(stderr, "get header error.\n");
        return 3;
    }
    putSNDheader(outfile, &snd, format);
    dlen = SNDdatalen(&snd, format);
    if (infile == stdin) {
	if ((tmp = tmpfile()) == NULL) return 1;
	for (j=1; j<=dlen; j++) fputc(fgetc(infile), tmp);
	fclose(infile);
	if (fseek(tmp, 0L, SEEK_SET) < 0) return 1;
	infile = tmp;
#ifdef DEBUG2
	fprintf(stderr, "pass0\n");
#endif
    }
#ifdef DEBUG2
    fprintf(stderr, "pass1\n");
#endif
    ch = SNDchannels(&snd, format);
    blocks = SNDblocks(&snd, format);
    bs = SNDblocksize(&snd, format);
    fseek(infile, dlen - bs, SEEK_CUR);
#ifdef DEBUG2
    fprintf(stderr, "pass1.5 (%d)\n", len);
#endif
    for (j=1; j<=blocks; j++) {
	for (k=1; k<=ch; k++) {
	    x = SNDget1chleveldata(infile, &snd, format);
	    SNDput1chleveldata(outfile, x, &snd,format);
	}
#ifdef DEBUG2
	if (j%1000 == 0) fprintf(stderr, "pass1.7 %d\n", j);
#endif
	fseek(infile, - bs, SEEK_CUR);
	fseek(infile, - bs, SEEK_CUR);
    }
#ifdef DEBUG2
    fprintf(stderr, "pass2\n");
#endif
    if (format != E_AU && bs%2 && blocks%2) fputc(0, outfile);
    return 0;
}

int getarg(int argc, char **argv, FILE **infile, FILE **outfile)
{
    *outfile = stdout;
    *infile = stdin;

    while (--argc > 0) {
	if (**(++argv) == '-') {
	    switch (*(++*argv)) {
	    case 'h':
	    case 'H':
	    case '?': return 0;
	    case 'o':
		if (*outfile != stdout) return -3;
		if (*(++*argv) == '\0') { 
		    if (--argc <= 0) return -4;
		    else argv++;
		}
		if (!strcmp(*argv, "-")) *outfile = stdout;
		else if ((*outfile = fopen(*argv, "w")) == NULL) {
		    fprintf(stderr, "File [%s] open error.\n", *argv);
		    return -5;
		}
		break;
	    case '\0': break;
	    default: return -6;
	    }
	    if (**argv == '\0') { --*argv; break; }
	} else break;
    }
    if (argc > 1) {
#ifdef DEBUG1
	fprintf(stderr, "DEBUG1: %d\n", argc);
#endif
	return -7;
    }
    if (argc < 1) return 1;
    if (!strcmp(*argv, "-")) *infile = stdin;
    else if ((*infile = fopen(*argv, "r")) == NULL) {
	fprintf(stderr, "File [%s] open error.\n", *argv);
	return -9;
    }
    return 1;
}

void usage(int ret)
{
    char *mess[] = {
	"Usage: sndrev (-o [outfile]) ([infile])",
	"   -o [outfile] : ϥեλ (default: ɸ)",
	"   [infile] : ϥե (ά: ɸ)",
	" ",
	" [1] ϥե '-' ꤷɸϤˤʤ롣",
	" [2] ղ󤷤롣",
	NULL
    };
    int j;

#ifdef DEBUG1
    printf("USAGE: %d\n", ret);
#endif
    for (j=0; mess[j]!=NULL; j++)
      fprintf(stderr, "%s\n", mess[j]);
}
