/*
 * ʣβ file  stereo file 
 * shige
 * 12/29 2003
 * 
 * $Id: sndstereo.c,v 1.16 2017-03-29 13:35:36+09 shige Exp $
 *
 * sndstereo (-o [outf]) [file1] [file2] (...)
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "common.h"

#define Maxchannel MAXChannel

typedef struct {
    char *fname;
    FILE *infile;
    SNDheader snd;
    int nblocks, fblocks, chnum;
    int chflag[Maxchannel];
} StereoData;

int main(int argc, char *argv[]);
void putstereo(FILE *outfile, StereoData *fdata, long int maxblocks, 
               int format, int fnum);
int getallheader(StereoData *fdata, long int *maxblocks, int *format, 
                 int fnum, int eachf, int headf);
int getarg(int argc, char *argv[], FILE **outfile, StereoData *fdata,
           int *Eachf, int *Headf);
void usage(int ret);

int main(int argc, char *argv[])
{
    SNDheader osnd;
    FILE *outfile = stdout;
    int fnum, format, ret, eachf, headf, och, bs;
    long int maxblocks;
    StereoData fdata[Maxchannel];

    fnum = getarg(argc, argv, &outfile, fdata, &eachf, &headf);
    if (fnum <= 0) { usage(fnum); return -fnum; }
    och = getallheader(fdata, &maxblocks, &format, fnum, eachf, headf);
    if (och < 1) { usage(och); return 10 - och;  }
    /* ϥإå */
    if ((ret = cpSNDheader(&osnd, &(fdata[0].snd), format)) < 0) 
      return 20 - ret;
    if ((ret = setSNDheader(&osnd, format, 0, och, 0, 0, maxblocks,
			    CH_CHANNEL|CH_BLOCKS)) < 0) 
      return 30 - ret;
    /* ϥإåν */
    putSNDheader(outfile, &osnd, format);
    /* ǡ pass1raw ǽ */
#ifdef DEBUG1
    {
	int j, k;
	for (j=0; j<fnum; j++) {
	    fprintf(stderr, "DEBUG: fdata[%d]: (%s):", j, 
		    fdata[j].fname);
	    fprintf(stderr, " (nblocks,fblocks,chnum) = (%d,%d,%d)\n",
		    fdata[j].nblocks, fdata[j].fblocks, fdata[j].chnum);
	    fprintf(stderr, " chflag[] = ");
	    for (k=0; k<fdata[j].chnum; k++)
	      fprintf(stderr, "%s%d", k ? ", " : "(", fdata[j].chflag[k]);
	    fprintf(stderr, ")\n");
	}
    }
#endif
    putstereo(outfile, fdata, maxblocks, format, fnum);

    bs = SNDblocksize(&osnd, format);
    if (format != E_AU && maxblocks%2 && och%2 && bs%2)
      fputc(0, outfile);
    fclose(outfile);
    return 0;
}

void putstereo(FILE *outfile, StereoData *fdata, long int maxblocks, 
	       int format, int fnum)
{
    long int j;
    int m, k, ch;
    SNDheader *snd;
    FILE *infile;

    for (j=1L; j<=maxblocks; j++)
      for (m=0; m<fnum; m++) { /* fdata[m] ν */
	  ch = fdata[m].chnum;
	  snd = &(fdata[m].snd);
	  infile = fdata[m].infile;
	  if (fdata[m].nblocks > 0 || fdata[m].fblocks <= 0) {
	      /* null  (ϤϤʤ) */
	      for (k=0; k<ch; k++) 
		if (fdata[m].chflag[k])
		  SNDputnull1ch(outfile, snd, format);
	      if (fdata[m].nblocks > 0) fdata[m].nblocks --;
	  } else { /* file ǡ */
	      for (k=0; k<ch; k++) 
		if (fdata[m].chflag[k])
		  SNDpass1chrawdata(infile, outfile, snd, format);
		else SNDskip1chdata(infile, snd, format);
	      fdata[m].fblocks --;
	  }
      }
    return;
}

/* ե򳫤ơإåơchannel flag 
 */
int getallheader(StereoData *fdata, long int *maxblocks, int *format, 
		 int fnum, int eachf, int headf)
{
    int j, k, form0, form, ret, ch;
    int mask = CH_MAGIC|CH_FMCODE|CH_SMPLRATE|CH_BITPERSMPL;

    if (fnum < 1 || fnum > Maxchannel) return -1;
    k = 0;
    for (j=0; j<fnum; j++) {
	if (! strcmp(fdata[j].fname, "-")) {
	    if (++ k > 1) return -2;
	    else fdata[j].infile = stdin;
	} else {
	    fdata[j].infile = fopen(fdata[j].fname, "r");
	    if (fdata[j].infile == NULL) {
		fprintf(stderr, "File [%s] open error.\n", 
			fdata[j].fname);
		return -3;
	    }
	}
    }
    /* SNDheader μ.chnum, .fblocks  */
    if ((form0 = getSNDheader(fdata[0].infile, &(fdata[0].snd))) < 0
      || form0 == E_UNKNOWN) {
	fprintf(stderr, "getSNDheader error (%d:%d)\n", 1, form0);
	return -4;
    }
    fdata[0].chnum = SNDchannels(&(fdata[0].snd), form0);
    fdata[0].fblocks = SNDblocks(&(fdata[0].snd), form0);
    *format = form0;
    *maxblocks = fdata[0].fblocks;
    if (! eachf) ch = fdata[0].chnum;
    for (j=1; j<fnum; j++) {
	/* SNDheader μ0 ΤΤȤ */
	if ((form = getSNDheader(fdata[j].infile, &(fdata[j].snd))) < 0
	    || form != form0) {
	    fprintf(stderr, "getSNDheader error (%d:%d)\n", j + 1, 
		    form);
	    return -4;
	}
	ret = SNDchheaderMASK(&(fdata[0].snd), &(fdata[j].snd), form0,
			      mask);
	if (ret < 0) {
	    fprintf(stderr, "%d's header is not different to 1\n", 
		    j + 1);
	    return -5;
	}
	/* .chnum, .fblocks  */
	fdata[j].chnum = SNDchannels(&(fdata[j].snd), form0);
	fdata[j].fblocks = SNDblocks(&(fdata[j].snd), form0);
	/* *maxblocks, ch  */
	if (fdata[j].fblocks > *maxblocks)
	  *maxblocks = fdata[j].fblocks;
	if (eachf) { 
	    if (fdata[j].chnum > 1 && fdata[j].chnum < j + 1) {
		fprintf(stderr, 
			"%dth file's ch = %d (not enough).\n",
			j + 1, fdata[j].chnum);
		return -6;
	    }
	} else ch += fdata[j].chnum;
    }
    if (ch > Maxchannel) {
	fprintf(stderr, "Too may channels (%d) for output.\n", ch);
	return -7;
    }
    /* headf, eachf  .chflag[], .nblocks  */
    for (j=0; j<fnum; j++) {
	if (headf) fdata[j].nblocks = 0;
	else if (*maxblocks > fdata[j].fblocks) 
	  fdata[j].nblocks = *maxblocks - fdata[j].fblocks;
	if (eachf) {
	    if (fdata[j].chnum == 1) fdata[j].chflag[0] = 1;
	    else 
	      for (k=0; k<fdata[j].chnum; k++) 
		fdata[j].chflag[k] = (k == j) ? 1 : 0;
	} else {
	    for (k=0; k<fdata[j].chnum; k++) 
	      fdata[j].chflag[k] = 1;
	}
    }
    /*  channel ֤ */
    if (eachf) return fnum;
    else return ch;
}

int getarg(int argc, char *argv[], FILE **outfile, StereoData *fdata,
	   int *Eachf, int *Headf)
{
    int j;

    *Eachf = 1;
    *Headf = 1;
    while (-- argc > 0) {
	if (**(++ argv) == '-') {
	    switch (*(++ *argv)) {
	    case 'h':
	    case 'H':
	    case '?': return 0;
	    case 'o':
		if (*outfile != stdout) return -1;
		if (*(++ *argv) == '\0') { 
		    if (-- argc <= 0) return -2;
		    else argv++;
		}
		if (! strcmp(*argv, "-")) *outfile = stdout;
		else if ((*outfile = fopen(*argv, "w")) == NULL) {
		    fprintf(stderr, "File [%s] open error.\n", *argv);
		    return -3;
		}
		break;
	    case 'e': *Eachf = 1; break;
	    case 'a': *Eachf = 0; break;
	    case 'l': *Headf = 1; break;
	    case 'r': *Headf = 0; break;
	    case '\0': break;
	    default: return -4;
	    }
	    if (**argv == '\0') { -- *argv; break; }
	} else break;
    }
    if (argc > Maxchannel) return -5;
    for (j=0; j<argc; j++, argv++) fdata[j].fname = *argv;
    return argc;
}

void usage(int ret)
{
    char *mess[] = {
	"Usage: sndstereo (-a|-e) (-l|-r) (-o [outf]) [file1] (...)",
	"  -o [outf]: ϥեλ (default: ɸ)",
	"  -e/-a : 1 ͥ⡼ (default)/ͥ⡼",
	"  -l/-r : Ƭ· (default)/Ǹ·", 
	"",
	" [1] [file1], [file2](, ...)  channel ΥեȤƽ",
	"   ˥ƥ쥪 (¿ channel) ˹ʪϤ롣",
	" [2] ϥե뤬Υ (ñ channel) եξϡ",
	"   Ϥ¿ͥǡȤ롣",
	" [3] Ϥ¿ͥǡξ硢",
	"   1 ͥ⡼ (-e) Ǥϡn ܤΥե뤫 n ",
	"   ܤ 1 ͥΤߤѤ (n >= 3 ǡn ܤ",
	"    k ͥ (2 <= k <= n-1) ʤ饨顼)",
	"   ͥ⡼ (-a) Ǥϡ¿ͥǡΥ",
	"   ͥ⤹٤󤵤ǡϤ롣",
	" [4] 㤨",
	"     sndstereo -e file1 file2 file3 file4",
	"   νϤϡfile3 ΥǤʤϡfile3  3ch ",
	"   Ϥ 3ch ǡȤfile3  2ch ǡξ",
	"   ϥ顼Ȥʤ롣",
	"     sndstereo -a file1 file2 file3 file4",
	"   ξϡfile1, file2, file3, file4 ͥ",
	"   ĥǡϤ롣",
	" [5] Ĺ·äƤʤǡϰĹե˹碌­",
	"   ʤͥʬˤ̵ǡɲä롣",
	"   -l Ƭ· (default) ξϥǡƬ·Ǹ",
	"   ̵ɲä-r κǸ·ξϥǡκǸ·",
	"   Ƭ̵ɲä롣",
	NULL
    };
    int j;

#ifdef DEBUG1
    printf("USAGE: %d\n", ret);
#endif
    for (j=0; mess[j]!=NULL; j++) fprintf(stderr, "%s\n", mess[j]);
}
