/* 
 * au,wav,aiff  format ˤʤġѤ subroutine
 * common.c
 * shige
 * 12/27 2003
 * 
 * $Id: common.c,v 1.14 2005-08-29 17:00:56+09 shige Exp $
 */
/* 1)	header μưȽ⤳˴ޤޤ롣
 * 2)	Snddata, WAVdata, AIFFdata ΤȤ뤫
 */
#ifndef __COMMON_C__
#define __COMMON_C__

#include "common.h"

/* format ⤢ٲꤹ롣
 * AU: fmcode=1, smplrate=8000, channel=1
 * WAV: fmcode=1, bitpersmpl=8||16
 * AIFF: bitpersmpl=8||16
 */
int getSNDheader(FILE *file,SNDheader *snd)
{
    char magic[4];

    if(fread(magic,1,4,file)!=4) return E_UNKNOWN;
    if(strncmp(magic,".snd",4)==0){
	if(getSndheader_noseek2(file,&(snd->au))<0) return -1;
	(snd->au).magic=sto4bytei(magic);
#if 0
	if((snd->au).fmcode!=1 || (snd->au).channel!=1 
#else
	if((snd->au).fmcode!=1
#endif
	   || (snd->au).smplrate!=8000) return -7;
	else return E_AU;
    }
    else if(strncmp(magic,"RIFF",4)==0){
	if(getWAVheader_noseek2(file,&(snd->wav))<0) return -2;
	if((snd->wav).fmcode!=1) return -8;
	if((snd->wav).bitpersmpl!=8 && (snd->wav).bitpersmpl!=16) return -5;
	else return E_WAV;
    }
    else if(strncmp(magic,"FORM",4)==0){
	if(getAIFFheader_noseek2(file,&(snd->aiff))<0) return -3;
	if((snd->aiff).bitpersmpl!=8 && (snd->aiff).bitpersmpl!=16) return -6;
	else return E_AIFF;
    }
    else return -4;
}

int put1SNDheader(FILE *file,SNDheader *snd,int format)
{
    if(format==E_AU){ 
	putallheader(file,&(snd->au),1); return E_AU; 
    }
    else if(format==E_WAV){ 
	putallWAVheader(file,&(snd->wav),1); return E_WAV; 
    }
    else if(format==E_AIFF){ 
	putallAIFFheader(file,&(snd->aiff),1); return E_AIFF;
    }
    else return -1;
}

int putallSNDheader(FILE *file,SNDheader *snd,int N,int format)
{
    long int blocks;
    int j;

    if(format==E_AU) 
#if 0
      for(j=1,blocks=0L;j<=N;j++) blocks+=snd[j-1].au.datalen;
#else
      for(j=1,blocks=0L;j<=N;j++) 
	blocks+=snd[j-1].au.datalen/snd[j-1].au.channel;
#endif
    else if(format==E_WAV) 
      for(j=1,blocks=0L;j<=N;j++) 
	blocks+=snd[j-1].wav.datalen/snd[j-1].wav.blocksize;
    else if(format==E_AIFF)
      for(j=1,blocks=0L;j<=N;j++) blocks+=snd[j-1].aiff.flames;
    else return E_UNKNOWN;
    return putSNDheaderBlocks(file,snd,blocks,format);
}

int putallSNDheaderOpt(FILE *file,SNDheader *snd,int N,ConnOpt *opt,int format)
{
    long int blocks=0L,blk;
    int Nlen,len,addsp,j;
    double times;

    if(format!=E_AU && format!=E_WAV && format!=E_AIFF) return -1;
    if(N<1) return -2;
    for(j=1;j<=N;j++){
	switch(format){
#if 0
	case E_AU: blk=snd[j-1].au.datalen; break;
#else
	case E_AU: blk=snd[j-1].au.datalen/snd[j-1].au.channel; break;
#endif
	case E_WAV: blk=snd[j-1].wav.datalen/snd[j-1].wav.blocksize; break;
	case E_AIFF: blk=snd[j-1].aiff.flames; break;
	}	    
	len=opt[j-1].len; addsp=opt[j-1].addsp; times=opt[j-1].times;
	Nlen=(times>0.0)? blk/times : blk;
	blocks+=(len>0 && (addsp||Nlen>=len))?len:Nlen;
    }
    return putSNDheaderBlocks(file,snd,blocks,format);
}

int putSNDheaderBlocks(FILE *file,SNDheader *snd,int blocks,int format)
{
    SNDheader tmp;
    
    if(cpSNDheader(&tmp,snd,format)<0) return -1;
    if(format==E_AU){ 
#if 0
	/* AU Ǥ datalen=blocks */
	tmp.au.datalen=blocks;
#else
	/* AU Ǥ datalen=blocks*channel */ 
	tmp.au.datalen=blocks*(snd->au).channel;
#endif
	putallheader(file,&(tmp.au),1);
	return E_AU;
    }
    else if(format==E_WAV){ /* WAV Ǥ datalen=blocks*blocksize */
	tmp.wav.datalen=blocks*(snd->wav).blocksize;
	putallWAVheader(file,&(tmp.wav),1);
	return E_WAV;
    }
    else if(format==E_AIFF){ /* .datalen  putallAIFFheader() ϻȤʤ */
	tmp.aiff.flames=blocks;
	tmp.aiff.datalen=blocks*tmp.aiff.flamesize;
	putallAIFFheader(file,&(tmp.aiff),1);
	return E_AIFF;
    }
    else return E_UNKNOWN;
}

int putSNDheaderBlocksChannels(FILE *file,SNDheader *snd,int blocks,
			       int channels,int format)
{
    SNDheader tmp;
    int ch;
    
    if(cpSNDheader(&tmp,snd,format)<0) return -1;
    if(format==E_AU){
#if 0
	if(channels!=1) return -1; /*  */
#endif
	/* AU Ǥ datalen=blocks*channel */
	tmp.au.channel=channels;
	tmp.au.datalen=blocks*channels;
	putallheader(file,&(tmp.au),1);
	return E_AU;
    }
    else if(format==E_WAV){ /* WAV Ǥ datalen=blocks*blocksize */
	ch=(snd->wav).channel;
	tmp.wav.channel=channels;
	tmp.wav.blocksize=channels*((snd->wav).blocksize/ch);
	tmp.wav.bytepersec=channels*((snd->wav).bytepersec/ch);
	tmp.wav.datalen=blocks*tmp.wav.blocksize;
	putallWAVheader(file,&(tmp.wav),1);
	return E_WAV;
    }
    else if(format==E_AIFF){
	ch=(snd->aiff).channel;
	tmp.aiff.channel=channels;
	tmp.aiff.flamesize=channels*((snd->aiff).flamesize/ch);
	tmp.aiff.flames=blocks;
	tmp.aiff.datalen=blocks*tmp.aiff.flamesize;
	putallAIFFheader(file,&(tmp.aiff),1);
	return E_AIFF;
    }
    else return E_UNKNOWN;
}

int putSNDheaderBlocksSmplrate(FILE *file,SNDheader *snd,int blocks,
			       double smplrate,int format)
{
    SNDheader tmp;
    
    if(cpSNDheader(&tmp,snd,format)<0) return -1;
    if(format==E_AU){
	tmp.au.smplrate=smplrate;
#if 0
	/* AU Ǥ datalen=blocks */
	tmp.au.datalen=blocks;
#else
	/* AU Ǥ datalen=blocks*channel */
	tmp.au.datalen=blocks*(snd->au).channel;
#endif
	putallheader(file,&(tmp.au),1);
	return E_AU;
    }
    else if(format==E_WAV){ /* WAV Ǥ datalen=blocks*blocksize */
	tmp.wav.smplrate=(long int)(smplrate+0.5);
	tmp.wav.bytepersec=(long int)(smplrate+0.5)*(snd->wav).blocksize;
	tmp.wav.datalen=blocks*(snd->wav).blocksize;
	putallWAVheader(file,&(tmp.wav),1);
	return E_WAV;
    }
    else if(format==E_AIFF){
	tmp.aiff.flames=blocks;
	tmp.aiff.smplrate.x=smplrate;
	ConvertToIeeeExtended(smplrate,tmp.aiff.smplrate.s);
	tmp.aiff.datalen=blocks*(snd->aiff).flamesize;
	putallAIFFheader(file,&(tmp.aiff),1);
	return E_AIFF;
    }
    else return E_UNKNOWN;
}

/* ##### common usuable subroutine ##### */
int cpSNDheader(SNDheader *new,SNDheader *org,int format)
{
    int j;

    switch(format){
    case E_AU:
	(new->au).magic=(org->au).magic;
	(new->au).hlen=(org->au).hlen;
	(new->au).datalen=(org->au).datalen;
	(new->au).fmcode=(org->au).fmcode;
	(new->au).smplrate=(org->au).smplrate;
	(new->au).channel=(org->au).channel;
	(new->au).str=(org->au).str;
	return E_AU;
    case E_WAV:
	(new->wav).fmcode=(org->wav).fmcode;
	(new->wav).channel=(org->wav).channel;
	(new->wav).smplrate=(org->wav).smplrate;
	(new->wav).bytepersec=(org->wav).bytepersec;
	(new->wav).blocksize=(org->wav).blocksize;
	(new->wav).bitpersmpl=(org->wav).bitpersmpl;
	(new->wav).hlen=(org->wav).hlen;
	(new->wav).datalen=(org->wav).datalen;
	return E_WAV;
    case E_AIFF:
	(new->aiff).channel=(org->aiff).channel;
	(new->aiff).flames=(org->aiff).flames;
	(new->aiff).bitpersmpl=(org->aiff).bitpersmpl;
	(new->aiff).smplrate.x=(org->aiff).smplrate.x;
	for(j=1;j<=IEEEExtendedBytes;j++) 
	  (new->aiff).smplrate.s[j-1]=(org->aiff).smplrate.s[j-1];
	(new->aiff).flamesize=(org->aiff).flamesize;
	(new->aiff).hlen=(org->aiff).hlen;
	(new->aiff).datalen=(org->aiff).datalen;
	return E_AIFF;
    default: return -1;
    }
}

void SNDputtrans(FILE *infile,FILE *outfile,SNDheader *snd,int format,int olen,
		 double times)
{
    switch(format){
    case E_AU: puttrans(infile,outfile,&(snd->au),olen,times); return;
    case E_WAV: puttransWAV(infile,outfile,&(snd->wav),olen,times); return;
    case E_AIFF: puttransAIFF(infile,outfile,&(snd->aiff),olen,times); return;
    default: return;
    }
}

void SNDskip1chdata(FILE *infile,SNDheader *snd,int format)
{
    int bps=SNDbitpersmpl(snd,format),k;

    for(k=1;k<=bps/8;k++) fgetc(infile);
}

void SNDreadput1chdata(FILE *infile,FILE *outfile,SNDheader *snd,int format)
{
    int bps=SNDbitpersmpl(snd,format);
    short int x;

    switch(format){
    case E_AU: fputc(fgetc(infile),outfile); return;
    case E_WAV:
        if(bps==8) fputc(fgetc(infile),outfile);
        else{
	    read2bytetolittlei(infile,&x);
	    writelittleito2byte(outfile,x);
	}
        return;
    case E_AIFF:
        if(bps==8) fputc(fgetc(infile),outfile);
        else{
	    read2bytetoi(infile,&x);
	    writeito2byte(outfile,x);
	}
        return;
    default: return;
    }
}

void SNDreadput1chdatavol(FILE *infile,FILE *outfile,SNDheader *snd,int format,
			  double vol)
{
    int bps=SNDbitpersmpl(snd,format);
    short int x;
    unsigned char uc;
    char c;

    switch(format){
    case E_AU: 
	uc=fgetc(infile);
	x=ulaw2linear(uc);
	uc=linear2ulaw(x*vol+0.5);
	fputc(uc,outfile); 
	return;
    case E_WAV:
        if(bps==8){
	    uc=fgetc(infile);
	    uc=(uc-WAVPOS8bit)*vol+WAVPOS8bit+0.5;
	    fputc(uc,outfile);
	}
        else{
	    read2bytetolittlei(infile,&x);
	    x=(x-WAVPOS16bit)*vol+WAVPOS16bit+0.5;
	    writelittleito2byte(outfile,x);
	}
        return;
    case E_AIFF:
        if(bps==8){
	    c=fgetc(infile);
	    c=(c-AIFFPOS8bit)*vol+AIFFPOS8bit+0.5;
	    fputc(c,outfile);
	}
        else{
	    read2bytetoi(infile,&x);
	    x=(x-AIFFPOS16bit)*vol+AIFFPOS16bit+0.5;
	    writeito2byte(outfile,x);
	}
        return;
    default: return;
    }
}

void SNDputnull1ch(FILE *outfile,SNDheader *snd,int format)
{
    switch(format){
    case E_AU: fputc(AUNULL,outfile); return;
    case E_WAV:
        if((snd->wav).bitpersmpl==8) fputc(WAV8NULL,outfile);
        else writelittleito2byte(outfile,WAV16NULL);
        return;
    case E_AIFF:
        if((snd->aiff).bitpersmpl==8) fputc(AIFF8NULL,outfile);
        else writeito2byte(outfile,AIFF16NULL);
        return;
    default: return;
    }
}

int SNDput1chleveldata(FILE *outfile,double data,SNDheader *snd,int format)
{
    unsigned char uc;
    char c;
    short int x;

    if(data==0.0){ SNDputnull1ch(outfile,snd,format); return 0; }
    switch(format){
    case E_AU: 
	uc=linear2ulaw(data*AUSCALE+0.5);
	fputc(uc,outfile); return 0;
    case E_WAV:
        if((snd->wav).bitpersmpl==8){
	    uc=data*WAVSCALE8bit+WAVPOS8bit+0.5;
	    fputc(uc,outfile);
	}
        else{
	    x=data*WAVSCALE16bit+WAVPOS16bit+0.5;
	    writelittleito2byte(outfile,x);
	}
        return 0;
    case E_AIFF:
        if((snd->aiff).bitpersmpl==8){
	    c=data*AIFFSCALE8bit+AIFFPOS8bit+0.5;
	    fputc(c,outfile);
	}
        else{
	    x=data*AIFFSCALE16bit+AIFFPOS16bit+0.5;
	    writeito2byte(outfile,x);
	}
        return 0;
    default: return -1;
    }
}

double SNDget1chleveldata(FILE *infile,SNDheader *snd,int format)
{
    short int sx;
    unsigned char ucx;
    char cx;

    switch(format){
    case E_AU:
	return (double)ulaw2linear(fgetc(infile))/AUSCALE;
    case E_WAV:
	if((snd->wav).bitpersmpl==8){
	    ucx=fgetc(infile);
	    return (double)(ucx-WAVPOS8bit)/WAVSCALE8bit;
	}
	else{
	    read2bytetolittlei(infile,&sx);
	    return (double)(sx-WAVPOS16bit)/WAVSCALE16bit;
	}
    case E_AIFF:
	if((snd->aiff).bitpersmpl==8){
	    cx=fgetc(infile);
	    return (double)(cx-AIFFPOS8bit)/AIFFSCALE8bit;
	}
	else{
	    read2bytetoi(infile,&sx);
	    return (double)(sx-AIFFPOS16bit)/AIFFSCALE16bit;
	}
    default: return 0.0;
    }
}

int SNDblocksize(SNDheader *snd,int format)
{
#if 0
    if(format==E_AU) return 1;
#else
    if(format==E_AU) return (snd->au).channel;
#endif
    else if(format==E_WAV) return (snd->wav).blocksize;
    else if(format==E_AIFF) return (snd->aiff).flamesize;
    else return -1;
}

int SNDbitpersmpl(SNDheader *snd,int format)
{
    if(format==E_AU) return 8;
    else if(format==E_WAV) return (snd->wav).bitpersmpl;
    else if(format==E_AIFF) return (snd->aiff).bitpersmpl;
    else return -1;
}

int SNDchannels(SNDheader *snd,int format)
{
    if(format==E_AU) return (snd->au).channel;
    else if(format==E_WAV) return (snd->wav).channel;
    else if(format==E_AIFF) return (snd->aiff).channel;
    else return -1;
}

int SNDchheaderMASK(SNDheader *snd1,SNDheader *snd2,int format,int mask)
{
    switch(format){
    case E_AU: return chSndheaderMASK(&(snd1->au),&(snd2->au),mask);
    case E_WAV: return chWAVheaderMASK(&(snd1->wav),&(snd2->wav),mask);
    case E_AIFF: return chAIFFheaderMASK(&(snd1->aiff),&(snd2->aiff),mask);
    default: return -20;
    }
}

long int SNDblocks(SNDheader *snd,int format)
{
#if 0
    if(format==E_AU) return (snd->au).datalen;
#else
    if(format==E_AU) return (snd->au).datalen/(snd->au).channel;
#endif
    else if(format==E_WAV) return (snd->wav).datalen/(snd->wav).blocksize;
    else if(format==E_AIFF) return (snd->aiff).flames;
    else return -1;
}

long int SNDdatalen(SNDheader *snd,int format)
{
    /* return SNDblocksize(snd,format)*SNDblocks(snd,format); */
    if(format==E_AU) return (snd->au).datalen;
    else if(format==E_WAV) return (snd->wav).datalen;
    else if(format==E_AIFF) return (snd->aiff).datalen;
    else return -1;
}

long int SNDhlen(SNDheader *snd,int format)
{
    if(format==E_AU) return (snd->au).hlen;
    else if(format==E_WAV) return (snd->wav).hlen;
    else if(format==E_AIFF) return (snd->aiff).hlen;
    else return -1;
}

double SNDsmplrate(SNDheader *snd,int format)
{
    if(format==E_AU) return (snd->au).smplrate;
    else if(format==E_WAV) return (snd->wav).smplrate;
    else if(format==E_AIFF) return (snd->aiff).smplrate.x;
    else return -1;
}

double SNDgetmaxlevel(FILE *infile,SNDheader *snd,int format)
{
    long int blocks,j;
    double x,max;
    int ch;

    if(format!=E_AU && format!=E_WAV && format!=E_AIFF) return -1.0;
    blocks=SNDblocks(snd,format);
    ch=SNDchannels(snd,format);

    if(blocks*ch<1) return -1.0;
    x=SNDget1chleveldata(infile,snd,format);
    max=Abs(x);
    for(j=2;j<=blocks*ch;j++){
	x=SNDget1chleveldata(infile,snd,format);
	if(Abs(x)>max) max=Abs(x);
    }
    return max;
}

/* maxlevel[]  channel Ȥ뤳Ȥ򤢤餫 check 
 */ 
double SNDgetmaxlevelChannel(FILE *infile,SNDheader *snd,int format,
			     double maxlevel[])
{
    long int blocks,j;
    double x,max=-1.0;
    int ch,k;

    if(format!=E_AU && format!=E_WAV && format!=E_AIFF) return -1.0;
    blocks=SNDblocks(snd,format);
    ch=SNDchannels(snd,format);

    if(blocks*ch<1) return -1.0;
    
    for(k=1;k<=ch;k++){
	x=SNDget1chleveldata(infile,snd,format);
	maxlevel[k-1]=Abs(x);
	if(maxlevel[k-1]>max) max=maxlevel[k-1];
    }
    for(j=2;j<=blocks;j++)
      for(k=1;k<=ch;k++){
	  x=SNDget1chleveldata(infile,snd,format);
	  if(Abs(x)>maxlevel[k-1]) maxlevel[k-1]=Abs(x);
	  if(maxlevel[k-1]>max) max=maxlevel[k-1];
      }
    return max;
}

#endif /* __COMMON_C__ */
