/* WAV file ôʬ
 * shige
 * 10/01 2000
 * wavio.c
 *
 * $Id: wavio.c,v 1.19 2017-03-09 17:11:19+09 shige Exp $
 */
#ifndef __WAVIO_C__
#define __WAVIO_C__

#include "wavio.h"

/* #define DEBUG1 */
/* #define DEBUG2 */

/* wav file  header, chunk μ
 * λϥǡƬ
 * mode = 0: fseek  (chunk list Ϻʤ)
 * mode = 1: mode = 0 + chunk list 
 * mode = 5: myfseek  (stdin ) (chunk list Ϻʤ)
 * mode = 6: mode = 1 Ƭ 4 ХȤμ򤷤ʤ
*/
int getWAVheaderchunk(FILE *file, WAVdata *wd, Chunk *Ch, int mode)
{
    long int j;
    long int fsize, csize, curpos, dpos;
    Chunk *ch1;
    int chunks = 0;

    if (mode == 0 || mode == 1) fseek(file, 0, SEEK_SET);
    if (mode != 6) {
	if (read4bytetolittlei(file, &j) < 0 
	    || j != sto4bytelittlei("RIFF"))
	  return Err_readwavheader;
    }
    if (read4bytetolittlei(file, &fsize) < 0) return Err_readwavheader;
    fsize += 8;
    if (read4bytetolittlei(file, &j) < 0 
	|| j != sto4bytelittlei("WAVE"))
      return Err_readwavheader;
    curpos = 12L;
    /* chunk θ */
    while (1) {
	if (curpos > fsize - 8L) break;
	if (mode == 1) { /* chunk list  */
	    if (++ chunks > Maxchunks) return Err_too_many_chunks;
	    ch1 = &(Ch[chunks - 1]);
	    ch1->start = curpos;
	    if (fread(ch1->id, 4, 1, file) < 1 
		|| read4bytetolittlei(file, &(ch1->size)) < 0)
	      return Err_readwavheader;
	    csize = ch1->size;
	} else { /* chunk list  */
	    if (read4bytetolittlei(file, &j) < 0
		|| read4bytetolittlei(file, &csize) < 0)
	      return Err_readwavheader;
	}
	curpos += 8L;
	if ((mode == 1 && ! strncmp(ch1->id, "fmt ", 4))
	    || (mode != 1 && j == sto4bytelittlei("fmt "))) {
	    /* fmt chunk */
	    if (csize < 14L
	       || read2bytetolittlei(file, &(wd->fmcode)) < 0
	       || read2bytetolittlei(file, &(wd->channel)) < 0
	       || read4bytetolittlei(file, &(wd->smplrate)) < 0
	       || read4bytetolittlei(file, &(wd->bytepersec)) < 0
	       || read2bytetolittlei(file, &(wd->blocksize)) < 0)
	      return Err_readwavheader;
	    else curpos += 14L;
	    if (csize == 14L) {
		if (wd->channel <= 0) return Err_readwavheader;
		wd->bitpersmpl = wd->blocksize*8/wd->channel;
	    }
	    if (csize >= 16L) {
		if (read2bytetolittlei(file, &(wd->bitpersmpl)) < 0)
		  return Err_readwavheader;
		else curpos += 2L;
		if (csize > 16L) {
		    if (mode == 0 || mode == 1) 
		      fseek(file, csize - 16L, SEEK_CUR);
		    else WAVmyfseek(file, csize - 16L);
		    curpos += csize - 16L;
		}
	    } else return Err_readwavheader;
	} else if ((mode == 1 && ! strncmp(ch1->id, "data", 4))
		   || (mode != 1 && j == sto4bytelittlei("data"))) {
	    /* data chunk */
	    wd->datalen = csize;
	    wd->hlen = curpos;
	    if (mode == 1) {
		dpos = curpos;
		fseek(file, csize + csize%2, SEEK_CUR);
		curpos += csize + csize%2;
	    } else break;
	} else {
	    /* ʳ chunk */
	    if (mode == 0 || mode == 1)
	      fseek(file, csize + csize%2, SEEK_CUR);
	    else WAVmyfseek(file, csize + csize%2);
	    curpos += csize + csize%2;
	}
    }
    if (mode == 1) {
	fseek(file, dpos, SEEK_SET);
	return chunks;
    }
    else return No_err;
}

#if 0
/* wav file  header μ */
int getWAVheader(FILE *file, WAVdata *wd)
{
    long int j;
    long int fsize, csize;

    fseek(file, 0, SEEK_SET);
    if (read4bytetolittlei(file, &j) < 0 || j != sto4bytelittlei("RIFF"))
      return Err_readwavheader;
    if (read4bytetolittlei(file, &fsize) < 0) return Err_readwavheader;
    fsize += 8;
    if (read4bytetolittlei(file, &j) < 0 || j != sto4bytelittlei("WAVE"))
      return Err_readwavheader;
    /* chunk θ */
    while (1) {
	if (ftell(file) > fsize - 8) break;
	if (read4bytetolittlei(file, &j) < 0 
	    || read4bytetolittlei(file, &csize) < 0)
	  return Err_readwavheader;
	if (j == sto4bytelittlei("fmt ")) {
	    if (csize < 14
	       || read2bytetolittlei(file, &(wd->fmcode)) < 0
	       || read2bytetolittlei(file, &(wd->channel)) < 0
	       || read4bytetolittlei(file, &(wd->smplrate)) < 0
	       || read4bytetolittlei(file, &(wd->bytepersec)) < 0
	       || read2bytetolittlei(file, &(wd->blocksize)) < 0)
	      return Err_readwavheader;
	    if (csize == 14) {
		if (wd->channel <= 0) return Err_readwavheader;
		wd->bitpersmpl = wd->blocksize*8/wd->channel;
	    }
	    if (csize >= 16) {
		if (read2bytetolittlei(file, &(wd->bitpersmpl)) < 0)
		  return Err_readwavheader;
		if (csize > 16) fseek(file, csize - 16, SEEK_CUR);
	    } else return Err_readwavheader;
	} else if (j == sto4bytelittlei("data")) {
	    wd->datalen = csize;
	    wd->hlen = ftell(file);
	    break;
	} else fseek(file, csize + csize%2, SEEK_CUR);
    }
    return No_err;
}

/* getWAVheader  fseek() Ȥʤ
 * λ֤ data Ƭ
 */
int getWAVheader_noseek(FILE *file, WAVdata *wd)
{
    long int j;
    long int fsize, csize, curpos;

    /* fseek(file, 0, SEEK_SET); */
    if (read4bytetolittlei(file, &j) < 0 || j != sto4bytelittlei("RIFF"))
      return Err_readwavheader;
    if (read4bytetolittlei(file, &fsize) < 0) return Err_readwavheader;
    fsize += 8;
    if (read4bytetolittlei(file, &j) < 0 || j != sto4bytelittlei("WAVE"))
      return Err_readwavheader;
    curpos = 12L;
    /* chunk θ */
    while (1) {
	/* if (ftell(file) > fsize - 8) break; */
	if (curpos > fsize - 8) break;
	if (read4bytetolittlei(file, &j) < 0 
	    || read4bytetolittlei(file, &csize) < 0)
	  return Err_readwavheader;
	curpos += 8;
	if (j == sto4bytelittlei("fmt ")) {
	    if (csize < 14 
	       || read2bytetolittlei(file, &(wd->fmcode)) < 0
	       || read2bytetolittlei(file, &(wd->channel)) < 0
	       || read4bytetolittlei(file, &(wd->smplrate)) < 0
	       || read4bytetolittlei(file, &(wd->bytepersec)) < 0
	       || read2bytetolittlei(file, &(wd->blocksize)) < 0)
	      return Err_readwavheader;
	    else curpos += 14;
	    if (csize == 14) {
		if (wd->channel <= 0) return Err_readwavheader;
		wd->bitpersmpl = wd->blocksize*8/wd->channel;
	    }
	    if (csize >= 16) {
		if (read2bytetolittlei(file, &(wd->bitpersmpl)) < 0)
		  return Err_readwavheader;
		else curpos += 2;
		if (csize > 16) { 
		    WAVmyfseek(file, csize - 16); 
		    curpos += csize - 16; 
		}
	    } else return Err_readwavheader;
	} else if (j == sto4bytelittlei("data")) {
	    wd->datalen = csize;
	    wd->hlen = curpos;
	    break;
	} else {
	    WAVmyfseek(file, csize + csize%2);
	    curpos += csize + csize%2;
	} 
    }
    return No_err;
}

int getWAVheader_noseek2(FILE *file, WAVdata *wd)
{
    long int j;
    long int fsize, csize, curpos;

    /* fseek(file, 0, SEEK_SET); */
    /* if(read4bytetolittlei(file, &j) < 0 || j != sto4bytelittlei("RIFF"))
     *   return Err_readwavheader;
     */
    if (read4bytetolittlei(file, &fsize) < 0) return Err_readwavheader;
    fsize += 8;
    if (read4bytetolittlei(file, &j) < 0 || j != sto4bytelittlei("WAVE"))
      return Err_readwavheader;
    curpos = 12L;
    /* chunk θ */
    while (1) {
	/* if (ftell(file) > fsize - 8) break; */
	if (curpos > fsize - 8) break;
	if (read4bytetolittlei(file, &j) < 0 
	    || read4bytetolittlei(file, &csize) < 0)
	  return Err_readwavheader;
	curpos += 8;
	if (j == sto4bytelittlei("fmt ")) {
	    if (csize < 14 
	       || read2bytetolittlei(file, &(wd->fmcode)) < 0
	       || read2bytetolittlei(file, &(wd->channel)) < 0
	       || read4bytetolittlei(file, &(wd->smplrate)) < 0
	       || read4bytetolittlei(file, &(wd->bytepersec)) < 0
	       || read2bytetolittlei(file, &(wd->blocksize)) < 0)
	      return Err_readwavheader;
	    else curpos += 14;
	    if (csize == 14) {
		if (wd->channel <= 0) return Err_readwavheader;
		wd->bitpersmpl = wd->blocksize*8/wd->channel;
	    }
	    if (csize >= 16) {
		if (read2bytetolittlei(file, &(wd->bitpersmpl)) < 0)
		  return Err_readwavheader;
		else curpos += 2;
		if (csize > 16) { 
		    WAVmyfseek(file, csize - 16); 
		    curpos += csize - 16; 
		}
	    } else return Err_readwavheader;
	} else if (j == sto4bytelittlei("data")) {
	    wd->datalen = csize;
	    wd->hlen = curpos;
	    break;
	} else {
	    WAVmyfseek(file, csize + csize%2);
	    curpos += csize + csize%2;
	} 
    }
    return No_err;
}
#endif

void WAVmyfseek(FILE *file, int num)
{
    int j;

    for (j=1; j<=num; j++) fgetc(file);
}

#if 0
/* wav file  header μ & chunk list κ */
int getWAVinfo(FILE *file, WAVdata *wd, Chunk *Ch)
{
    long int j;
    long int fsize;
    Chunk *ch;
    int chunks = 0;

    fseek(file, 0, SEEK_SET);
    if (read4bytetolittlei(file, &j) < 0 || j != sto4bytelittlei("RIFF"))
      return Err_readwavheader;
    if (read4bytetolittlei(file, &fsize) < 0) return Err_readwavheader;
    fsize += 8;
    if (read4bytetolittlei(file, &j) < 0 || j != sto4bytelittlei("WAVE"))
      return Err_readwavheader;
    /* chunk θ */
    while (1) {
	if (ftell(file) > fsize - 8) break;
	if (++chunks > Maxchunks) return Err_too_many_chunks;
	ch = &(Ch[chunks - 1]);
	ch->start = ftell(file);
	if (fread(ch->id, 4, 1, file) < 1) return Err_readwavheader;
	if (read4bytetolittlei(file, &(ch->size)) < 0) 
	  return Err_readwavheader;
	if (strncmp(ch->id, "fmt ", 4) == 0) { /* format chunk */
	    if (ch->size < 14
	       || read2bytetolittlei(file, &(wd->fmcode)) < 0
	       || read2bytetolittlei(file, &(wd->channel)) < 0
	       || read4bytetolittlei(file, &(wd->smplrate)) < 0
	       || read4bytetolittlei(file, &(wd->bytepersec)) < 0
	       || read2bytetolittlei(file, &(wd->blocksize)) < 0)
	      return Err_readwavheader;
	    if (ch->size == 14) { 
		/* bitpersmpl ʤΤ support */
		if (wd->channel <= 0) return Err_readwavheader;
		wd->bitpersmpl = wd->blocksize*8/wd->channel;
	    }
	    if (ch->size >= 16) {
		if (read2bytetolittlei(file, &(wd->bitpersmpl)) < 0)
		  return Err_readwavheader;
		if (ch->size > 16) fseek(file, ch->size - 16, SEEK_CUR);
	    } else return Err_readwavheader;
	} else {
	    if (strncmp(ch->id, "data", 4) == 0) { /* data chunk */
		wd->datalen = ch->size;
		wd->hlen = ftell(file);
	    }
	    fseek(file, ch->size, SEEK_CUR);
	}
	if ((ch->size)%2) fseek(file, 1, SEEK_CUR);
	/* word alignment */
    }
    return chunks;
}
#endif

/* WAV header  */
int chWAVheader(WAVdata *wd1, WAVdata *wd2)
{
    if (wd1->fmcode != wd2->fmcode) return Err_diffmcode;
    if (wd1->channel != wd2->channel) return Err_diffchannel;
    if (wd1->smplrate != wd2->smplrate) return Err_diffsmplrate;
    if (wd1->bytepersec != wd2->bytepersec) return Err_diffbytepersec;
    if (wd1->blocksize != wd2->blocksize) return Err_diffblocksize;
    if (wd1->bitpersmpl != wd2->bitpersmpl) return Err_diffbitpersmpl;
    return No_err;
}

/* WAV header  */
int chWAVheaderMASK(WAVdata *wd1, WAVdata *wd2, int mask)
{
    if (mask&WAV_FMCODE && wd1->fmcode != wd2->fmcode)
      return Err_diffmcode;
    if (mask&WAV_CHANNEL && wd1->channel != wd2->channel)
      return Err_diffchannel;
    if (mask&WAV_SMPLRATE && wd1->smplrate != wd2->smplrate)
      return Err_diffsmplrate;
    if (mask&WAV_BYTEPERSEC && wd1->bytepersec != wd2->bytepersec)
      return Err_diffbytepersec;
    if (mask&WAV_BLOCKSIZE && wd1->blocksize != wd2->blocksize)
      return Err_diffblocksize;
    if (mask&WAV_BITPERSMPL && wd1->bitpersmpl != wd2->bitpersmpl)
      return Err_diffbitpersmpl;
    return No_err;
}

/* header ν */
void putWAVheader(FILE *file, WAVdata *wd)
{
    writelittleito4byte(file, sto4bytelittlei("RIFF"));
    /* fputs("RIFF", file); */
    writelittleito4byte(file, 4 + 4 + 4 + 16 + 4 + 4 + wd->datalen 
			+ (wd->datalen)%2);
    writelittleito4byte(file, sto4bytelittlei("WAVE"));
    writelittleito4byte(file, sto4bytelittlei("fmt "));
    writelittleito4byte(file, 16);
    writelittleito2byte(file, wd->fmcode);
    writelittleito2byte(file, wd->channel);
    writelittleito4byte(file, wd->smplrate);
    writelittleito4byte(file, wd->bytepersec);
    writelittleito2byte(file, wd->blocksize);
    writelittleito2byte(file, wd->bitpersmpl);
    writelittleito4byte(file, sto4bytelittlei("data"));
    writelittleito4byte(file, wd->datalen);
}

#endif /* __WAVIO_C__ */
